#include <amxmodx>
#include <amxmisc>

#define PLUGIN_NAME		"Restrict Client"
#define PLUGIN_VERSION	"1.1"
#define PLUGIN_AUTHOR	"Author"


#define charsmax(%1)	(sizeof(%1)-1)

#define SUBNET_MAX		1024

new reason[] = "Sorry, to play on this server need STEAM client"

new subnet_count
new subnet_ip		[SUBNET_MAX]
new subnet_mask		[SUBNET_MAX]

public plugin_init()
{
	register_plugin ( PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR )
}

public plugin_cfg()
{
	set_task ( 1.0, "get_subnets" )
}

public client_authorized ( id )
{
	new authid[44], ip[16]
	get_user_authid ( id, authid, charsmax ( authid ) )
	get_user_ip ( id, ip, charsmax ( ip ), 1 )

	if ( containi ( authid, "STEAM_0:" ) == -1 )
	{
		if ( is_subnet ( ip ) != -1 || access ( id, ADMIN_LEVEL_H ) )
			return PLUGIN_CONTINUE

		server_cmd ( "kick #%d ^"%s^"", get_user_userid ( id ), reason )
	}

	return PLUGIN_CONTINUE
}

public get_subnets()
{
	static configsdir[64], filename[64], file
	get_configsdir ( configsdir, charsmax ( configsdir ) )
	format ( filename, charsmax ( filename ), "%s/access_subnets.ini", configsdir )

	file = fopen ( filename, "r" )

	if ( file )
	{
		new subnet[32], ip[16], mask[4], _ip
		subnet_count = 0

		while ( ( subnet_count < ( SUBNET_MAX ) ) && !feof ( file ) )
		{
			fgets ( file, subnet, charsmax ( subnet ) )

			if ( ( subnet[0] != ';' ) && ( subnet[0] != '/' ) && strtok ( subnet, ip, charsmax ( ip ), mask, charsmax ( mask ), '/', 1 ) )
			{
				_ip = ip_to_num ( ip )

				if ( _ip != -1 )
				{
					subnet_ip[subnet_count] = apply_mask ( _ip, str_to_num ( mask ) )
					subnet_mask[subnet_count] = str_to_num ( mask )
					subnet_count++
				}
			}
		}

		fclose ( file )
	}

	else
	{
		log_amx ( "File ^"%s^" not found", filename )
	}
}

stock ip_to_num ( const ip[] )
{
	static string[16], byte_0[4], byte_A[4], byte_B[4], byte_C[4], _ip

	copy ( string, charsmax ( string ), ip )
	replace_all ( string, charsmax ( string ), ".", " ")

	if ( parse ( string, byte_0, charsmax ( byte_0 ), byte_A, charsmax ( byte_A ), byte_B, charsmax ( byte_B ), byte_C, charsmax ( byte_C ) ) != 4 ) return -1

	_ip =  ( str_to_num ( byte_0 ) & 255 ) << 24
	_ip += ( str_to_num ( byte_A ) & 255 ) << 16
	_ip += ( str_to_num ( byte_B ) & 255 ) << 8
	_ip +=   str_to_num ( byte_C ) & 255

	return _ip
}

stock apply_mask ( const ip, const mask )
{
	new shift = 32 - clamp ( mask, 0 , 32 )
	return ( ip >> shift ) << shift
}

stock is_subnet ( const ip[] )
{
	new _ip = ip_to_num ( ip )
	for ( new i = 0; i < subnet_count; ++i ) if ( subnet_ip[i] == apply_mask ( _ip, subnet_mask[i] ) ) return i
	return -1
}
